1 # Test framework for git. See t/README for usage.
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # Test the binaries we have just built. The tests are kept in
19 # t/ subdirectory and are run in 'trash directory' subdirectory.
20 if test -z "$TEST_DIRECTORY"
22 # We allow tests to override this, in case they want to run tests
23 # outside of t/, e.g. for running tests on the test library
27 # ensure that TEST_DIRECTORY is an absolute path so that it
28 # is valid even if the current working directory is changed
29 TEST_DIRECTORY
=$
(cd "$TEST_DIRECTORY" && pwd) ||
exit 1
31 if test -z "$TEST_OUTPUT_DIRECTORY"
33 # Similarly, override this to store the test-results subdir
35 TEST_OUTPUT_DIRECTORY
=$TEST_DIRECTORY
37 GIT_BUILD_DIR
="$TEST_DIRECTORY"/..
39 ################################################################
40 # It appears that people try to run tests without building...
41 "$GIT_BUILD_DIR/git" >/dev
/null
44 echo >&2 'error: you do not seem to have built git yet.'
48 .
"$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
49 export PERL_PATH SHELL_PATH
51 # if --tee was passed, write the output not only to the terminal, but
52 # additionally to the file test-results/$BASENAME.out, too.
53 case "$GIT_TEST_TEE_STARTED, $* " in
55 # do not redirect again
57 *' --tee '*|
*' --va'*|
*' --verbose-log '*)
58 mkdir
-p "$TEST_OUTPUT_DIRECTORY/test-results"
59 BASE
="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
61 # Make this filename available to the sub-process in case it is using
63 GIT_TEST_TEE_OUTPUT_FILE
=$BASE.out
64 export GIT_TEST_TEE_OUTPUT_FILE
66 # Truncate before calling "tee -a" to get rid of the results
67 # from any previous runs.
68 >"$GIT_TEST_TEE_OUTPUT_FILE"
70 (GIT_TEST_TEE_STARTED
=done ${SHELL_PATH} "$0" "$@" 2>&1;
71 echo $?
>"$BASE.exit") |
tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
72 test "$(cat "$BASE.
exit")" = 0
77 # For repeatability, reset the environment to known value.
78 # TERM is sanitized below, after saving color control sequences.
83 export LANG LC_ALL PAGER TZ
85 # A call to "unset" with no arguments causes at least Solaris 10
86 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
87 # deriving from the command substitution clustered with the other
89 unset VISUAL EMAIL LANGUAGE COLUMNS $
("$PERL_PATH" -e '
91 my $ok = join("|", qw(
104 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
105 print join("\n", @vars);
107 unset XDG_CONFIG_HOME
109 GIT_AUTHOR_EMAIL
=author@example.com
110 GIT_AUTHOR_NAME
='A U Thor'
111 GIT_COMMITTER_EMAIL
=committer@example.com
112 GIT_COMMITTER_NAME
='C O Mitter'
113 GIT_MERGE_VERBOSITY
=5
114 GIT_MERGE_AUTOEDIT
=no
115 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
116 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
117 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
120 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
122 export GIT_TRACE_BARE
124 if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
126 GIT_INDEX_VERSION
="$TEST_GIT_INDEX_VERSION"
127 export GIT_INDEX_VERSION
130 # Add libc MALLOC and MALLOC_PERTURB test
131 # only if we are not executing the test with valgrind
132 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev
/null ||
133 test -n "$TEST_NO_MALLOC_CHECK"
135 setup_malloc_check
() {
138 teardown_malloc_check
() {
142 setup_malloc_check
() {
143 MALLOC_CHECK_
=3 MALLOC_PERTURB_
=165
144 export MALLOC_CHECK_ MALLOC_PERTURB_
146 teardown_malloc_check
() {
147 unset MALLOC_CHECK_ MALLOC_PERTURB_
151 : ${ASAN_OPTIONS=detect_leaks=0}
154 # Protect ourselves from common misconfiguration to export
155 # CDPATH into the environment
161 case $
(echo $GIT_TRACE |
tr "[A-Z]" "[a-z]") in
169 # A regexp to match 5 and 40 hexdigits
170 _x05
='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
171 _x40
="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
174 _z40
=0000000000000000000000000000000000000000
176 EMPTY_TREE
=4b825dc642cb6eb9a060e54bf8d69288fbee4904
177 EMPTY_BLOB
=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
183 # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
184 # when case-folding filenames
185 u200c
=$
(printf '\342\200\214')
187 export _x05 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB
189 # Each test should start with something like this, after copyright notices:
191 # test_description='Description of this test...
192 # This test checks if command xyzzy does the right thing...
195 test "x$TERM" != "xdumb" && (
197 tput bold
>/dev
/null
2>&1 &&
198 tput setaf
1 >/dev
/null
2>&1 &&
199 tput sgr0
>/dev
/null
2>&1
203 while test "$#" -ne 0
206 -d|
--d|
--de|
--deb|
--debu|
--debug)
208 -i|
--i|
--im|
--imm|
--imme|
--immed|
--immedi|
--immedia|
--immediat|
--immediate)
209 immediate
=t
; shift ;;
210 -l|
--l|
--lo|
--lon|
--long|
--long-|
--long-t|
--long-te|
--long-tes|
--long-test|
--long-tests)
211 GIT_TEST_LONG
=t
; export GIT_TEST_LONG
; shift ;;
213 shift; test "$#" -ne 0 ||
{
214 echo 'error: -r requires an argument' >&2;
217 run_list
=$1; shift ;;
219 run_list
=${1#--*=}; shift ;;
220 -h|
--h|
--he|
--hel|
--help)
222 -v|
--v|
--ve|
--ver|
--verb|
--verbo|
--verbos|
--verbose)
225 verbose_only
=${1#--*=}
227 -q|
--q|
--qu|
--qui|
--quie|
--quiet)
228 # Ignore --quiet under a TAP::Harness. Saying how many tests
229 # passed without the ok/not ok details is always an error.
230 test -z "$HARNESS_ACTIVE" && quiet
=t
; shift ;;
232 with_dashes
=t
; shift ;;
235 --va|
--val|
--valg|
--valgr|
--valgri|
--valgrin|
--valgrind)
242 valgrind_only
=${1#--*=}
245 shift ;; # was handled already
250 GIT_TEST_CHAIN_LINT
=1
253 GIT_TEST_CHAIN_LINT
=0
263 echo "error: unknown test option '$1'" >&2; exit 1 ;;
267 if test -n "$valgrind_only"
269 test -z "$valgrind" && valgrind
=memcheck
270 test -z "$verbose" && verbose_only
="$valgrind_only"
271 elif test -n "$valgrind"
278 # Save the color control sequences now rather than run tput
279 # each time say_color() is called. This is done for two
281 # * TERM will be changed to dumb
282 # * HOME will be changed to a temporary directory and tput
283 # might need to read ~/.terminfo from the original HOME
284 # directory to get the control sequences
285 # Note: This approach assumes the control sequences don't end
286 # in a newline for any terminal of interest (command
287 # substitutions strip trailing newlines). Given that most
288 # (all?) terminals in common use are related to ECMA-48, this
289 # shouldn't be a problem.
290 say_color_error
=$
(tput bold
; tput setaf
1) # bold red
291 say_color_skip
=$
(tput setaf
4) # blue
292 say_color_warn
=$
(tput setaf
3) # brown/yellow
293 say_color_pass
=$
(tput setaf
2) # green
294 say_color_info
=$
(tput setaf
6) # cyan
295 say_color_reset
=$
(tput sgr0
)
296 say_color_
="" # no formatting for normal text
298 test -z "$1" && test -n "$quiet" && return
299 eval "say_color_color=\$say_color_$1"
301 printf "%s\\n" "$say_color_color$*$say_color_reset"
305 test -z "$1" && test -n "$quiet" && return
315 say_color error
"error: $*"
324 if test -n "$HARNESS_ACTIVE"
326 if test "$verbose" = t ||
test -n "$verbose_only"
328 printf 'Bail out! %s\n' \
329 'verbose mode forbidden under TAP harness; try --verbose-log'
334 test "${test_description}" != "" ||
335 error
"Test script did not set test_description."
337 if test "$help" = "t"
339 printf '%s\n' "$test_description"
346 if test "$verbose_log" = "t"
348 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
349 elif test "$verbose" = "t"
353 exec 4>/dev
/null
3>/dev
/null
356 # Send any "-x" output directly to stderr to avoid polluting tests
357 # which capture stderr. We can do this unconditionally since it
358 # has no effect if tracing isn't turned on.
360 # Note that this sets up the trace fd as soon as we assign the variable, so it
361 # must come after the creation of descriptor 4 above. Likewise, we must never
362 # unset this, as it has the side effect of closing descriptor 4, which we
363 # use to show verbose tests to the user.
365 # Note also that we don't need or want to export it. The tracing is local to
366 # this shell, and we would not want to influence any shells we exec.
375 test_external_has_tap
=0
379 if test -n "$GIT_EXIT_OK"
383 echo >&5 "FATAL: Unexpected exit with code $code"
392 # The user-facing functions are loaded from a separate file so that
393 # test_perf subshells can have them too
394 .
"$TEST_DIRECTORY/test-lib-functions.sh"
396 # You are not expected to call test_ok_ and test_failure_ directly, use
397 # the test_expect_* functions instead.
400 test_success
=$
(($test_success + 1))
401 say_color
"" "ok $test_count - $@"
405 test_failure
=$
(($test_failure + 1))
406 say_color error
"not ok $test_count - $1"
408 printf '%s\n' "$*" |
sed -e 's/^/# /'
409 test "$immediate" = "" ||
{ GIT_EXIT_OK
=t
; exit 1; }
412 test_known_broken_ok_
() {
413 test_fixed
=$
(($test_fixed+1))
414 say_color error
"ok $test_count - $@ # TODO known breakage vanished"
417 test_known_broken_failure_
() {
418 test_broken
=$
(($test_broken+1))
419 say_color warn
"not ok $test_count - $@ # TODO known breakage"
423 test "$debug" = "" ||
eval "$1"
426 match_pattern_list
() {
429 test -z "$*" && return 1
440 match_test_selector_list
() {
445 test -z "$1" && return 0
447 # Both commas and whitespace are accepted as separators.
453 # If the first selector is negative we include by default.
461 orig_selector
=$selector
467 selector
=${selector##?}
471 test -z "$selector" && continue
475 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev
/null
477 echo "error: $title: invalid non-numeric in range" \
478 "start: '$orig_selector'" >&2
481 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev
/null
483 echo "error: $title: invalid non-numeric in range" \
484 "end: '$orig_selector'" >&2
489 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev
/null
491 echo "error: $title: invalid non-numeric in test" \
492 "selector: '$orig_selector'" >&2
497 # Short cut for "obvious" cases
498 test -z "$include" && test -z "$positive" && continue
499 test -n "$include" && test -n "$positive" && continue
503 if test $arg -le ${selector#-}
509 if test $arg -ge ${selector%-}
515 if test ${selector%%-*} -le $arg \
516 && test $arg -le ${selector#*-}
522 if test $arg -eq $selector
533 maybe_teardown_verbose
() {
534 test -z "$verbose_only" && return
535 exec 4>/dev
/null
3>/dev
/null
540 maybe_setup_verbose
() {
541 test -z "$verbose_only" && return
542 if match_pattern_list
$test_count $verbose_only
545 # Emit a delimiting blank line when going from
546 # non-verbose to verbose. Within verbose mode the
547 # delimiter is printed by test_expect_*. The choice
548 # of the initial $last_verbose is such that before
549 # test 1, we do not print it.
550 test -z "$last_verbose" && echo >&3 ""
553 exec 4>/dev
/null
3>/dev
/null
556 last_verbose
=$verbose
559 maybe_teardown_valgrind
() {
560 test -z "$GIT_VALGRIND" && return
561 GIT_VALGRIND_ENABLED
=
564 maybe_setup_valgrind
() {
565 test -z "$GIT_VALGRIND" && return
566 if test -z "$valgrind_only"
568 GIT_VALGRIND_ENABLED
=t
571 GIT_VALGRIND_ENABLED
=
572 if match_pattern_list
$test_count $valgrind_only
574 GIT_VALGRIND_ENABLED
=t
579 test "$trace" = t
&& test "$verbose" = t
582 # This is a separate function because some tests use
583 # "return" to end a test_expect_success block early
584 # (and we want to make sure we run any cleanup like
586 test_eval_inner_
() {
587 # Do not add anything extra (including LF) after '$*'
594 # We run this block with stderr redirected to avoid extra cruft
595 # during a "-x" trace. Once in "set -x" mode, we cannot prevent
596 # the shell from printing the "set +x" to turn it off (nor the saving
597 # of $? before that). But we can make sure that the output goes to
600 # The test itself is run with stderr put back to &4 (so either to
601 # /dev/null, or to the original stderr if --verbose was used).
603 test_eval_inner_
"$@" </dev
/null
>&3 2>&4
608 if test "$test_eval_ret_" != 0
610 say_color error
>&4 "error: last command exited with \$?=$test_eval_ret_"
614 return $test_eval_ret_
621 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
622 # turn off tracing for this test-eval, as it simply creates
623 # confusing noise in the "-x" output
626 # 117 is magic because it is unlikely to match the exit
627 # code of other programs
628 if test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?
" 3>&1)"
630 error
"bug in the test script: broken &&-chain or run-away HERE-DOC: $1"
638 teardown_malloc_check
640 if test -z "$immediate" ||
test $eval_ret = 0 ||
641 test -n "$expecting_failure" && test "$test_cleanup" != ":"
644 test_eval_
"$test_cleanup"
645 teardown_malloc_check
647 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
655 test_count
=$
(($test_count+1))
662 maybe_teardown_valgrind
663 maybe_teardown_verbose
669 if match_pattern_list
$this_test.
$test_count $GIT_SKIP_TESTS
672 skipped_reason
="GIT_SKIP_TESTS"
674 if test -z "$to_skip" && test -n "$test_prereq" &&
675 ! test_have_prereq
"$test_prereq"
680 if test "$missing_prereq" != "$test_prereq"
682 of_prereq
=" of $test_prereq"
684 skipped_reason
="missing $missing_prereq${of_prereq}"
686 if test -z "$to_skip" && test -n "$run_list" &&
687 ! match_test_selector_list
'--run' $test_count "$run_list"
690 skipped_reason
="--run"
695 say_color skip
>&3 "skipping test: $@"
696 say_color skip
"ok $test_count # skip $1 ($skipped_reason)"
705 # stub; perf-lib overrides it
706 test_at_end_hook_
() {
713 if test -z "$HARNESS_ACTIVE"
715 test_results_dir
="$TEST_OUTPUT_DIRECTORY/test-results"
716 mkdir
-p "$test_results_dir"
718 test_results_path
="$test_results_dir/${base%.sh}.counts"
720 cat >"$test_results_path" <<-EOF
722 success $test_success
730 if test "$test_fixed" != 0
732 say_color error
"# $test_fixed known breakage(s) vanished; please update test(s)"
734 if test "$test_broken" != 0
736 say_color warn
"# still have $test_broken known breakage(s)"
738 if test "$test_broken" != 0 ||
test "$test_fixed" != 0
740 test_remaining
=$
(( $test_count - $test_broken - $test_fixed ))
741 msg
="remaining $test_remaining test(s)"
743 test_remaining
=$test_count
744 msg
="$test_count test(s)"
746 case "$test_failure" in
748 if test $test_external_has_tap -eq 0
750 if test $test_remaining -gt 0
752 say_color pass
"# passed all $msg"
755 # Maybe print SKIP message
756 test -z "$skip_all" || skip_all
="# SKIP $skip_all"
757 case "$test_count" in
759 say
"1..$test_count${skip_all:+ $skip_all}"
762 test -z "$skip_all" ||
763 say_color warn
"$skip_all"
771 test -d "$TRASH_DIRECTORY" ||
772 error
"Tests passed but trash directory already removed before test cleanup; aborting"
774 cd "$TRASH_DIRECTORY/.." &&
775 rm -fr "$TRASH_DIRECTORY" ||
776 error
"Tests passed but test cleanup failed; aborting"
783 if test $test_external_has_tap -eq 0
785 say_color error
"# failed $test_failure among $msg"
794 if test -n "$valgrind"
798 test "$1" = "$(readlink "$2")" ||
{
806 while test -d "$2".lock
808 say
"Waiting for lock on $2."
815 make_valgrind_symlink
() {
816 # handle only executables, unless they are shell libraries that
817 # need to be in the exec-path.
819 test "# " = "$(head -c 2 <"$1")" ||
822 base
=$
(basename "$1")
825 symlink_target
="$GIT_BUILD_DIR/t/helper/$base"
828 symlink_target
="$GIT_BUILD_DIR/$base"
831 # do not override scripts
832 if test -x "$symlink_target" &&
833 test ! -d "$symlink_target" &&
834 test "#!" != "$(head -c 2 < "$symlink_target")"
836 symlink_target
=..
/valgrind.sh
840 symlink_target
=..
/unprocessed-script
842 # create the link, or replace it if it is out of date
843 make_symlink
"$symlink_target" "$GIT_VALGRIND/bin/$base" ||
exit
846 # override all git executables in TEST_DIRECTORY/..
847 GIT_VALGRIND
=$TEST_DIRECTORY/valgrind
848 mkdir
-p "$GIT_VALGRIND"/bin
849 for file in $GIT_BUILD_DIR/git
* $GIT_BUILD_DIR/t
/helper
/test-
*
851 make_valgrind_symlink
$file
853 # special-case the mergetools loadables
854 make_symlink
"$GIT_BUILD_DIR"/mergetools
"$GIT_VALGRIND/bin/mergetools"
859 ls "$path"/git-
* 2> /dev
/null |
862 make_valgrind_symlink
"$file"
866 PATH
=$GIT_VALGRIND/bin
:$PATH
867 GIT_EXEC_PATH
=$GIT_VALGRIND/bin
869 GIT_VALGRIND_MODE
="$valgrind"
870 export GIT_VALGRIND_MODE
871 GIT_VALGRIND_ENABLED
=t
872 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED
=
873 export GIT_VALGRIND_ENABLED
874 elif test -n "$GIT_TEST_INSTALLED"
876 GIT_EXEC_PATH
=$
($GIT_TEST_INSTALLED/git
--exec-path) ||
877 error
"Cannot run git from $GIT_TEST_INSTALLED."
878 PATH
=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
879 GIT_EXEC_PATH
=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
880 else # normal case, use ../bin-wrappers only unless $with_dashes:
881 git_bin_dir
="$GIT_BUILD_DIR/bin-wrappers"
882 if ! test -x "$git_bin_dir/git"
884 if test -z "$with_dashes"
886 say
"$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
890 PATH
="$git_bin_dir:$PATH"
891 GIT_EXEC_PATH
=$GIT_BUILD_DIR
892 if test -n "$with_dashes"
894 PATH
="$GIT_BUILD_DIR:$PATH"
897 GIT_TEMPLATE_DIR
="$GIT_BUILD_DIR"/templates
/blt
898 GIT_CONFIG_NOSYSTEM
=1
900 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
902 if test -z "$GIT_TEST_CMP"
904 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
906 GIT_TEST_CMP
="$DIFF -c"
908 GIT_TEST_CMP
="$DIFF -u"
912 GITPERLLIB
="$GIT_BUILD_DIR"/perl
/blib
/lib
:"$GIT_BUILD_DIR"/perl
/blib
/arch
/auto
/Git
914 test -d "$GIT_BUILD_DIR"/templates
/blt ||
{
915 error
"You haven't built things yet, have you?"
918 if ! test -x "$GIT_BUILD_DIR"/t
/helper
/test-chmtime
920 echo >&2 'You need to build test-chmtime:'
921 echo >&2 'Run "make t/helper/test-chmtime" in the source (toplevel) directory'
926 TRASH_DIRECTORY
="trash directory.$(basename "$0" .sh)"
927 test -n "$root" && TRASH_DIRECTORY
="$root/$TRASH_DIRECTORY"
928 case "$TRASH_DIRECTORY" in
929 /*) ;; # absolute path is good
930 *) TRASH_DIRECTORY
="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
932 rm -fr "$TRASH_DIRECTORY" ||
{
934 echo >&5 "FATAL: Cannot prepare test area"
938 HOME
="$TRASH_DIRECTORY"
939 GNUPGHOME
="$HOME/gnupg-home-not-used"
940 export HOME GNUPGHOME
942 if test -z "$TEST_NO_CREATE_REPO"
944 test_create_repo
"$TRASH_DIRECTORY"
946 mkdir
-p "$TRASH_DIRECTORY"
948 # Use -P to resolve symlinks in our working directory so that the cwd
949 # in subprocesses like git equals our $PWD (for pathname comparisons).
950 cd -P "$TRASH_DIRECTORY" ||
exit 1
953 this_test
=${this_test%%-*}
954 if match_pattern_list
"$this_test" $GIT_SKIP_TESTS
956 say_color info
>&3 "skipping test $this_test altogether"
957 skip_all
="skip all tests in $this_test"
961 # Provide an implementation of the 'yes' utility
978 # Fix some commands on Windows
982 # Windows has its own (incompatible) sort and find
992 # git sees Windows-style pwd
996 # no POSIX permissions
997 # backslashes in pathspec are converted to '/'
998 # exec does not inherit the PID
999 test_set_prereq MINGW
1000 test_set_prereq NATIVE_CRLF
1001 test_set_prereq SED_STRIPS_CR
1002 test_set_prereq GREP_STRIPS_CR
1003 GIT_TEST_CMP
=mingw_test_cmp
1006 test_set_prereq POSIXPERM
1007 test_set_prereq EXECKEEPSPID
1008 test_set_prereq CYGWIN
1009 test_set_prereq SED_STRIPS_CR
1010 test_set_prereq GREP_STRIPS_CR
1013 test_set_prereq POSIXPERM
1014 test_set_prereq BSLASHPSPEC
1015 test_set_prereq EXECKEEPSPID
1019 ( COLUMNS
=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1020 test -z "$NO_PERL" && test_set_prereq PERL
1021 test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
1022 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1023 test -n "$USE_LIBPCRE1$USE_LIBPCRE2" && test_set_prereq PCRE
1024 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1026 # Can we rely on git's output in the C locale?
1027 if test -n "$GETTEXT_POISON"
1029 GIT_GETTEXT_POISON
=YesPlease
1030 export GIT_GETTEXT_POISON
1031 test_set_prereq GETTEXT_POISON
1033 test_set_prereq C_LOCALE_OUTPUT
1036 # Use this instead of test_cmp to compare files that contain expected and
1037 # actual output from git commands that can be translated. When running
1038 # under GETTEXT_POISON this pretends that the command produced expected
1041 test -n "$GETTEXT_POISON" || test_cmp
"$@"
1044 # Use this instead of "grep expected-string actual" to see if the
1045 # output from a git command that can be translated either contains an
1046 # expected string, or does not contain an unwanted one. When running
1047 # under GETTEXT_POISON this pretends that the command produced expected
1050 if test -n "$GETTEXT_POISON"
1053 elif test "x!" = "x$1"
1062 test_lazy_prereq PIPE
'
1063 # test whether the filesystem supports FIFOs
1069 rm -f testfifo && mkfifo testfifo
1074 test_lazy_prereq SYMLINKS
'
1075 # test whether the filesystem supports symbolic links
1076 ln -s x y && test -h y
1079 test_lazy_prereq FILEMODE
'
1080 test "$(git config --bool core.filemode)" = true
1083 test_lazy_prereq CASE_INSENSITIVE_FS
'
1084 echo good >CamelCase &&
1085 echo bad >camelcase &&
1086 test "$(cat CamelCase)" != good
1089 test_lazy_prereq UTF8_NFD_TO_NFC
'
1090 # check whether FS converts nfd unicode to nfc
1091 auml=$(printf "\303\244")
1092 aumlcdiar=$(printf "\141\314\210")
1102 test_lazy_prereq AUTOIDENT
'
1103 sane_unset GIT_AUTHOR_NAME &&
1104 sane_unset GIT_AUTHOR_EMAIL &&
1105 git var GIT_AUTHOR_IDENT
1108 test_lazy_prereq EXPENSIVE
'
1109 test -n "$GIT_TEST_LONG"
1112 test_lazy_prereq USR_BIN_TIME
'
1113 test -x /usr/bin/time
1116 test_lazy_prereq NOT_ROOT
'
1121 test_lazy_prereq JGIT
'
1125 # SANITY is about "can you correctly predict what the filesystem would
1126 # do by only looking at the permission bits of the files and
1127 # directories?" A typical example of !SANITY is running the test
1128 # suite as root, where a test may expect "chmod -r file && cat file"
1129 # to fail because file is supposed to be unreadable after a successful
1130 # chmod. In an environment (i.e. combination of what filesystem is
1131 # being used and who is running the tests) that lacks SANITY, you may
1132 # be able to delete or create a file when the containing directory
1133 # doesn't have write permissions, or access a file even if the
1134 # containing directory doesn't have read or execute permissions.
1136 test_lazy_prereq SANITY
'
1137 mkdir SANETESTD.1 SANETESTD.2 &&
1139 chmod +w SANETESTD.1 SANETESTD.2 &&
1140 >SANETESTD.1/x 2>SANETESTD.2/x &&
1141 chmod -w SANETESTD.1 &&
1142 chmod -r SANETESTD.1/x &&
1143 chmod -rx SANETESTD.2 ||
1144 error "bug in test sript: cannot prepare SANETESTD"
1146 ! test -r SANETESTD.1/x &&
1147 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1150 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1151 rm -rf SANETESTD.1 SANETESTD.2 ||
1152 error "bug in test sript: cannot clean SANETESTD"
1156 test FreeBSD
!= $uname_s || GIT_UNZIP
=${GIT_UNZIP:-/usr/local/bin/unzip}
1157 GIT_UNZIP
=${GIT_UNZIP:-unzip}
1158 test_lazy_prereq UNZIP
'
1163 run_with_limited_cmdline
() {
1164 (ulimit -s 128 && "$@")
1167 test_lazy_prereq CMDLINE_LIMIT
'run_with_limited_cmdline true'
1170 git version
--build-options |
1171 sed -ne "s/^$1: //p"
1174 test_lazy_prereq LONG_IS_64BIT
'
1175 test 8 -le "$(build_option sizeof-long)"
1178 test_lazy_prereq TIME_IS_64BIT
'test-date is64bit'
1179 test_lazy_prereq TIME_T_IS_64BIT
'test-date time_t-is64bit'